/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "dclick_options.h"

static int DclickOptionsDisplayPrivateIndex;

static CompMetadata dclickOptionsMetadata;

static CompPluginVTable *dclickPluginVTable = NULL;
CompPluginVTable dclickOptionsVTable;

#define DCLICK_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, DclickOptions, o)
#define DCLICK_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, DclickOptions, o)

typedef struct _DclickOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[DclickDisplayOptionNum];
    dclickDisplayOptionChangeNotifyProc notify[DclickDisplayOptionNum];
    unsigned int click_buttons;
    unsigned int click_mods;
    unsigned int call_type;
} DclickOptionsDisplay;

typedef struct _DclickOptionsScreen
{
} DclickOptionsScreen;

CompListValue * dclickGetClickButtons (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionClickButtons].value.list;
}

unsigned int dclickGetClickButtonsMask (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return od->click_buttons;
}

CompOption * dclickGetClickButtonsOption (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionClickButtons];
}

void dclickSetClickButtonsNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify)
{
    DCLICK_OPTIONS_DISPLAY(d);
    od->notify[DclickDisplayOptionClickButtons] = notify;
}

CompListValue * dclickGetClickMods (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionClickMods].value.list;
}

unsigned int dclickGetClickModsMask (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return od->click_mods;
}

CompOption * dclickGetClickModsOption (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionClickMods];
}

void dclickSetClickModsNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify)
{
    DCLICK_OPTIONS_DISPLAY(d);
    od->notify[DclickDisplayOptionClickMods] = notify;
}

CompListValue * dclickGetPluginNames (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionPluginNames].value.list;
}

CompOption * dclickGetPluginNamesOption (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionPluginNames];
}

void dclickSetPluginNamesNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify)
{
    DCLICK_OPTIONS_DISPLAY(d);
    od->notify[DclickDisplayOptionPluginNames] = notify;
}

CompListValue * dclickGetActionNames (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionActionNames].value.list;
}

CompOption * dclickGetActionNamesOption (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionActionNames];
}

void dclickSetActionNamesNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify)
{
    DCLICK_OPTIONS_DISPLAY(d);
    od->notify[DclickDisplayOptionActionNames] = notify;
}

CompListValue * dclickGetCallType (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionCallType].value.list;
}

unsigned int dclickGetCallTypeMask (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return od->call_type;
}

CompOption * dclickGetCallTypeOption (CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[DclickDisplayOptionCallType];
}

void dclickSetCallTypeNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify)
{
    DCLICK_OPTIONS_DISPLAY(d);
    od->notify[DclickDisplayOptionCallType] = notify;
}

CompOption * dclickGetDisplayOption (CompDisplay *d, DclickDisplayOptions num)
{
    DCLICK_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo dclickOptionsDisplayOptionInfo[] = {
    { "click_buttons", "list", "<type>int</type>", 0, 0 },
    { "click_mods", "list", "<type>int</type>", 0, 0 },
    { "plugin_names", "list", "<type>string</type>", 0, 0 },
    { "action_names", "list", "<type>string</type>", 0, 0 },
    { "call_type", "list", "<type>int</type>", 0, 0 },
};

static Bool dclickOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    DCLICK_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, DclickDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case DclickDisplayOptionClickButtons:
        if (compSetDisplayOption (d, o, value))
        {
            int i;
            od->click_buttons = 0;
            for (i = 0; i < o->value.list.nValue; i++)
                od->click_buttons |= (1 << o->value.list.value[i].i);
            if (od->notify[DclickDisplayOptionClickButtons])
                (*od->notify[DclickDisplayOptionClickButtons]) (d, o, DclickDisplayOptionClickButtons);
            return TRUE;
        }
        break;
     case DclickDisplayOptionClickMods:
        if (compSetDisplayOption (d, o, value))
        {
            int i;
            od->click_mods = 0;
            for (i = 0; i < o->value.list.nValue; i++)
                od->click_mods |= (1 << o->value.list.value[i].i);
            if (od->notify[DclickDisplayOptionClickMods])
                (*od->notify[DclickDisplayOptionClickMods]) (d, o, DclickDisplayOptionClickMods);
            return TRUE;
        }
        break;
     case DclickDisplayOptionPluginNames:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DclickDisplayOptionPluginNames])
                (*od->notify[DclickDisplayOptionPluginNames]) (d, o, DclickDisplayOptionPluginNames);
            return TRUE;
        }
        break;
     case DclickDisplayOptionActionNames:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DclickDisplayOptionActionNames])
                (*od->notify[DclickDisplayOptionActionNames]) (d, o, DclickDisplayOptionActionNames);
            return TRUE;
        }
        break;
     case DclickDisplayOptionCallType:
        if (compSetDisplayOption (d, o, value))
        {
            int i;
            od->call_type = 0;
            for (i = 0; i < o->value.list.nValue; i++)
                od->call_type |= (1 << o->value.list.value[i].i);
            if (od->notify[DclickDisplayOptionCallType])
                (*od->notify[DclickDisplayOptionCallType]) (d, o, DclickDisplayOptionCallType);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * dclickOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    DCLICK_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = DclickDisplayOptionNum;
    return od->opt;
}

static Bool dclickOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    DclickOptionsScreen *os;
    
    DCLICK_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(DclickOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    
    return TRUE;
}

static void dclickOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    DCLICK_OPTIONS_SCREEN (s);
    DCLICK_OPTIONS_DISPLAY (s->display);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool dclickOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    DclickOptionsDisplay *od;
   CompOption *o;
    int i;
    
    
    od = calloc (1, sizeof(DclickOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[DclickOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &dclickOptionsMetadata, dclickOptionsDisplayOptionInfo, od->opt, DclickDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }
    o = &od->opt[DclickDisplayOptionClickButtons];
    od->click_buttons = 0;
    for (i = 0; i < o->value.list.nValue; i++)
        od->click_buttons |= (1 << o->value.list.value[i].i);

    o = &od->opt[DclickDisplayOptionClickMods];
    od->click_mods = 0;
    for (i = 0; i < o->value.list.nValue; i++)
        od->click_mods |= (1 << o->value.list.value[i].i);

    o = &od->opt[DclickDisplayOptionCallType];
    od->call_type = 0;
    for (i = 0; i < o->value.list.nValue; i++)
        od->call_type |= (1 << o->value.list.value[i].i);


    return TRUE;
}

static void dclickOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    DCLICK_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, DclickDisplayOptionNum);

    free (od);
    d->base.privates[DclickOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool dclickOptionsInit (CompPlugin *p)
{
    DclickOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (DclickOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&dclickOptionsMetadata, "dclick",dclickOptionsDisplayOptionInfo, DclickDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&dclickOptionsMetadata, "dclick");
    if (dclickPluginVTable && dclickPluginVTable->init)
        return dclickPluginVTable->init (p);
    return TRUE;
}

static void dclickOptionsFini (CompPlugin *p)
{
    if (dclickPluginVTable && dclickPluginVTable->fini)
        dclickPluginVTable->fini (p);

    if (DclickOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (DclickOptionsDisplayPrivateIndex);

    compFiniMetadata (&dclickOptionsMetadata);
}

static CompBool dclickOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) dclickOptionsInitDisplay,
        (InitPluginObjectProc) dclickOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void dclickOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) dclickOptionsFiniDisplay,
        (FiniPluginObjectProc) dclickOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool dclickOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = dclickOptionsInitObject (p, o);
    if (dclickPluginVTable->initObject)
        rv &= dclickPluginVTable->initObject (p, o);
    return rv;
}

static void dclickOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (dclickPluginVTable->finiObject)
        dclickPluginVTable->finiObject (p, o);
    dclickOptionsFiniObject (p, o);
}

static CompOption * dclickOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) dclickOptionsGetDisplayOptions,
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool dclickOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) dclickOptionsSetDisplayOption,
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
dclickOptionsGetMetadata (CompPlugin *plugin)
{
    return &dclickOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!dclickPluginVTable)
    {
        dclickPluginVTable = getCompPluginInfo ();
        memcpy(&dclickOptionsVTable, dclickPluginVTable, sizeof(CompPluginVTable));
        dclickOptionsVTable.getMetadata = dclickOptionsGetMetadata;
        dclickOptionsVTable.init = dclickOptionsInit;
        dclickOptionsVTable.fini = dclickOptionsFini;
        dclickOptionsVTable.initObject = dclickOptionsInitObjectWrapper;
        dclickOptionsVTable.finiObject = dclickOptionsFiniObjectWrapper;
        dclickOptionsVTable.getObjectOptions = dclickOptionsGetObjectOptions;
	dclickOptionsVTable.setObjectOption = dclickOptionsSetObjectOption;
	
    }
    return &dclickOptionsVTable;
}

