/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _DCLICK_OPTIONS_H
#define _DCLICK_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    DclickDisplayOptionClickButtons,
    DclickDisplayOptionClickMods,
    DclickDisplayOptionPluginNames,
    DclickDisplayOptionActionNames,
    DclickDisplayOptionCallType,
    DclickDisplayOptionNum
} DclickDisplayOptions;

typedef void (*dclickDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, DclickDisplayOptions num);

CompOption *dclickGetDisplayOption (CompDisplay *d, DclickDisplayOptions num);

typedef enum
{
    DclickScreenOptionNum
} DclickScreenOptions;

typedef void (*dclickScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, DclickScreenOptions num);

CompOption *dclickGetScreenOption (CompScreen *s, DclickScreenOptions num);

typedef enum
{
    ClickButtonsButton1 = 0,
    ClickButtonsButton2 = 1,
    ClickButtonsButton3 = 2,
    ClickButtonsButton4 = 3,
    ClickButtonsButton5 = 4,
    ClickButtonsButton6 = 5,
    ClickButtonsButton7 = 6,
} DclickClickButtonsEnum;

typedef enum
{
    ClickModsControl = 0,
    ClickModsAlt = 1,
    ClickModsSuper = 2,
    ClickModsShift = 3,
    ClickModsControlAlt = 4,
    ClickModsControlShift = 5,
    ClickModsControlSuper = 6,
    ClickModsAltShift = 7,
    ClickModsAltSuper = 8,
    ClickModsShiftSuper = 9,
    ClickModsShiftAlt = 10,
    ClickModsNone = 11,
} DclickClickModsEnum;

typedef enum
{
    CallTypeHold = 0,
    CallTypeToggle = 1,
} DclickCallTypeEnum;

#define ClickButtonsButton1Mask (1 << 0)
#define ClickButtonsButton2Mask (1 << 1)
#define ClickButtonsButton3Mask (1 << 2)
#define ClickButtonsButton4Mask (1 << 3)
#define ClickButtonsButton5Mask (1 << 4)
#define ClickButtonsButton6Mask (1 << 5)
#define ClickButtonsButton7Mask (1 << 6)


#define ClickModsControlMask (1 << 0)
#define ClickModsAltMask (1 << 1)
#define ClickModsSuperMask (1 << 2)
#define ClickModsShiftMask (1 << 3)
#define ClickModsControlAltMask (1 << 4)
#define ClickModsControlShiftMask (1 << 5)
#define ClickModsControlSuperMask (1 << 6)
#define ClickModsAltShiftMask (1 << 7)
#define ClickModsAltSuperMask (1 << 8)
#define ClickModsShiftSuperMask (1 << 9)
#define ClickModsShiftAltMask (1 << 10)
#define ClickModsNoneMask (1 << 11)


#define CallTypeHoldMask (1 << 0)
#define CallTypeToggleMask (1 << 1)


CompListValue *  dclickGetClickButtons (CompDisplay *d);
unsigned int     dclickGetClickButtonsMask (CompDisplay *d);
CompOption *     dclickGetClickButtonsOption (CompDisplay *d);
void             dclickSetClickButtonsNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify);

CompListValue *  dclickGetClickMods (CompDisplay *d);
unsigned int     dclickGetClickModsMask (CompDisplay *d);
CompOption *     dclickGetClickModsOption (CompDisplay *d);
void             dclickSetClickModsNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify);

CompListValue *  dclickGetPluginNames (CompDisplay *d);
CompOption *     dclickGetPluginNamesOption (CompDisplay *d);
void             dclickSetPluginNamesNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify);

CompListValue *  dclickGetActionNames (CompDisplay *d);
CompOption *     dclickGetActionNamesOption (CompDisplay *d);
void             dclickSetActionNamesNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify);

CompListValue *  dclickGetCallType (CompDisplay *d);
unsigned int     dclickGetCallTypeMask (CompDisplay *d);
CompOption *     dclickGetCallTypeOption (CompDisplay *d);
void             dclickSetCallTypeNotify (CompDisplay *d, dclickDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
