/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _LAZYPOINTER_OPTIONS_H
#define _LAZYPOINTER_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    LazypointerDisplayOptionCentreOnFocus,
    LazypointerDisplayOptionCentreOnActivate,
    LazypointerDisplayOptionCentreOnPlace,
    LazypointerDisplayOptionSpeed,
    LazypointerDisplayOptionInitiateWindowKey,
    LazypointerDisplayOptionInitiateScreenKey,
    LazypointerDisplayOptionInitiateLeftKey,
    LazypointerDisplayOptionInitiateRightKey,
    LazypointerDisplayOptionInitiateUpKey,
    LazypointerDisplayOptionInitiateDownKey,
    LazypointerDisplayOptionNum
} LazypointerDisplayOptions;

typedef void (*lazypointerDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, LazypointerDisplayOptions num);

CompOption *lazypointerGetDisplayOption (CompDisplay *d, LazypointerDisplayOptions num);

typedef enum
{
    LazypointerScreenOptionNum
} LazypointerScreenOptions;

typedef void (*lazypointerScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, LazypointerScreenOptions num);

CompOption *lazypointerGetScreenOption (CompScreen *s, LazypointerScreenOptions num);

Bool             lazypointerGetCentreOnFocus (CompDisplay *d);
CompOption *     lazypointerGetCentreOnFocusOption (CompDisplay *d);
void             lazypointerSetCentreOnFocusNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

Bool             lazypointerGetCentreOnActivate (CompDisplay *d);
CompOption *     lazypointerGetCentreOnActivateOption (CompDisplay *d);
void             lazypointerSetCentreOnActivateNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

Bool             lazypointerGetCentreOnPlace (CompDisplay *d);
CompOption *     lazypointerGetCentreOnPlaceOption (CompDisplay *d);
void             lazypointerSetCentreOnPlaceNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

float            lazypointerGetSpeed (CompDisplay *d);
CompOption *     lazypointerGetSpeedOption (CompDisplay *d);
void             lazypointerSetSpeedNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

CompAction *     lazypointerGetInitiateWindowKey (CompDisplay *d);
void             lazypointerSetInitiateWindowKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             lazypointerSetInitiateWindowKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     lazypointerGetInitiateWindowKeyOption (CompDisplay *d);
void             lazypointerSetInitiateWindowKeyNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

CompAction *     lazypointerGetInitiateScreenKey (CompDisplay *d);
void             lazypointerSetInitiateScreenKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             lazypointerSetInitiateScreenKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     lazypointerGetInitiateScreenKeyOption (CompDisplay *d);
void             lazypointerSetInitiateScreenKeyNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

CompAction *     lazypointerGetInitiateLeftKey (CompDisplay *d);
void             lazypointerSetInitiateLeftKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             lazypointerSetInitiateLeftKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     lazypointerGetInitiateLeftKeyOption (CompDisplay *d);
void             lazypointerSetInitiateLeftKeyNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

CompAction *     lazypointerGetInitiateRightKey (CompDisplay *d);
void             lazypointerSetInitiateRightKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             lazypointerSetInitiateRightKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     lazypointerGetInitiateRightKeyOption (CompDisplay *d);
void             lazypointerSetInitiateRightKeyNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

CompAction *     lazypointerGetInitiateUpKey (CompDisplay *d);
void             lazypointerSetInitiateUpKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             lazypointerSetInitiateUpKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     lazypointerGetInitiateUpKeyOption (CompDisplay *d);
void             lazypointerSetInitiateUpKeyNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

CompAction *     lazypointerGetInitiateDownKey (CompDisplay *d);
void             lazypointerSetInitiateDownKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             lazypointerSetInitiateDownKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     lazypointerGetInitiateDownKeyOption (CompDisplay *d);
void             lazypointerSetInitiateDownKeyNotify (CompDisplay *d, lazypointerDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
