/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _NEWTON_OPTIONS_H
#define _NEWTON_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    NewtonDisplayOptionTriggerPhysicsKey,
    NewtonDisplayOptionTriggerRotationKey,
    NewtonDisplayOptionMouseInvertKey,
    NewtonDisplayOptionFreeWindowKey,
    NewtonDisplayOptionPinKey,
    NewtonDisplayOptionBounceConstant,
    NewtonDisplayOptionFrictionConstant,
    NewtonDisplayOptionGravity,
    NewtonDisplayOptionMouseAttraction,
    NewtonDisplayOptionMouseAttractionMode,
    NewtonDisplayOptionMouseStrength,
    NewtonDisplayOptionMouseStop,
    NewtonDisplayOptionNum
} NewtonDisplayOptions;

typedef void (*newtonDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, NewtonDisplayOptions num);

CompOption *newtonGetDisplayOption (CompDisplay *d, NewtonDisplayOptions num);

typedef enum
{
    NewtonScreenOptionNum
} NewtonScreenOptions;

typedef void (*newtonScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, NewtonScreenOptions num);

CompOption *newtonGetScreenOption (CompScreen *s, NewtonScreenOptions num);

CompAction *     newtonGetTriggerPhysicsKey (CompDisplay *d);
void             newtonSetTriggerPhysicsKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             newtonSetTriggerPhysicsKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     newtonGetTriggerPhysicsKeyOption (CompDisplay *d);
void             newtonSetTriggerPhysicsKeyNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

CompAction *     newtonGetTriggerRotationKey (CompDisplay *d);
void             newtonSetTriggerRotationKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             newtonSetTriggerRotationKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     newtonGetTriggerRotationKeyOption (CompDisplay *d);
void             newtonSetTriggerRotationKeyNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

CompAction *     newtonGetMouseInvertKey (CompDisplay *d);
void             newtonSetMouseInvertKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             newtonSetMouseInvertKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     newtonGetMouseInvertKeyOption (CompDisplay *d);
void             newtonSetMouseInvertKeyNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

CompAction *     newtonGetFreeWindowKey (CompDisplay *d);
void             newtonSetFreeWindowKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             newtonSetFreeWindowKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     newtonGetFreeWindowKeyOption (CompDisplay *d);
void             newtonSetFreeWindowKeyNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

CompAction *     newtonGetPinKey (CompDisplay *d);
void             newtonSetPinKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             newtonSetPinKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     newtonGetPinKeyOption (CompDisplay *d);
void             newtonSetPinKeyNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

float            newtonGetBounceConstant (CompDisplay *d);
CompOption *     newtonGetBounceConstantOption (CompDisplay *d);
void             newtonSetBounceConstantNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

float            newtonGetFrictionConstant (CompDisplay *d);
CompOption *     newtonGetFrictionConstantOption (CompDisplay *d);
void             newtonSetFrictionConstantNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

float            newtonGetGravity (CompDisplay *d);
CompOption *     newtonGetGravityOption (CompDisplay *d);
void             newtonSetGravityNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

Bool             newtonGetMouseAttraction (CompDisplay *d);
CompOption *     newtonGetMouseAttractionOption (CompDisplay *d);
void             newtonSetMouseAttractionNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

Bool             newtonGetMouseAttractionMode (CompDisplay *d);
CompOption *     newtonGetMouseAttractionModeOption (CompDisplay *d);
void             newtonSetMouseAttractionModeNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

int              newtonGetMouseStrength (CompDisplay *d);
CompOption *     newtonGetMouseStrengthOption (CompDisplay *d);
void             newtonSetMouseStrengthNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

Bool             newtonGetMouseStop (CompDisplay *d);
CompOption *     newtonGetMouseStopOption (CompDisplay *d);
void             newtonSetMouseStopNotify (CompDisplay *d, newtonDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
