/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "peek_options.h"

static int PeekOptionsDisplayPrivateIndex;

static CompMetadata peekOptionsMetadata;

static CompPluginVTable *peekPluginVTable = NULL;
CompPluginVTable peekOptionsVTable;

#define PEEK_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, PeekOptions, o)
#define PEEK_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, PeekOptions, o)

typedef struct _PeekOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[PeekDisplayOptionNum];
    peekDisplayOptionChangeNotifyProc notify[PeekDisplayOptionNum];
} PeekOptionsDisplay;

typedef struct _PeekOptionsScreen
{
    CompOption opt[PeekScreenOptionNum];
    peekScreenOptionChangeNotifyProc notify[PeekScreenOptionNum];
} PeekOptionsScreen;

int peekGetTimeout (CompDisplay *d)
{
    PEEK_OPTIONS_DISPLAY(d);
    return od->opt[PeekDisplayOptionTimeout].value.i;
}

CompOption * peekGetTimeoutOption (CompDisplay *d)
{
    PEEK_OPTIONS_DISPLAY(d);
    return &od->opt[PeekDisplayOptionTimeout];
}

void peekSetTimeoutNotify (CompDisplay *d, peekDisplayOptionChangeNotifyProc notify)
{
    PEEK_OPTIONS_DISPLAY(d);
    od->notify[PeekDisplayOptionTimeout] = notify;
}

CompMatch * peekGetWindowMatch (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return &os->opt[PeekScreenOptionWindowMatch].value.match;
}

CompOption * peekGetWindowMatchOption (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return &os->opt[PeekScreenOptionWindowMatch];
}

void peekSetWindowMatchNotify (CompScreen *s, peekScreenOptionChangeNotifyProc notify)
{
    PEEK_OPTIONS_SCREEN(s);
    os->notify[PeekScreenOptionWindowMatch] = notify;
}

int peekGetActiveOpacity (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return os->opt[PeekScreenOptionActiveOpacity].value.i;
}

CompOption * peekGetActiveOpacityOption (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return &os->opt[PeekScreenOptionActiveOpacity];
}

void peekSetActiveOpacityNotify (CompScreen *s, peekScreenOptionChangeNotifyProc notify)
{
    PEEK_OPTIONS_SCREEN(s);
    os->notify[PeekScreenOptionActiveOpacity] = notify;
}

int peekGetPassiveOpacity (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return os->opt[PeekScreenOptionPassiveOpacity].value.i;
}

CompOption * peekGetPassiveOpacityOption (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return &os->opt[PeekScreenOptionPassiveOpacity];
}

void peekSetPassiveOpacityNotify (CompScreen *s, peekScreenOptionChangeNotifyProc notify)
{
    PEEK_OPTIONS_SCREEN(s);
    os->notify[PeekScreenOptionPassiveOpacity] = notify;
}

Bool peekGetCurrentViewport (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return os->opt[PeekScreenOptionCurrentViewport].value.b;
}

CompOption * peekGetCurrentViewportOption (CompScreen *s)
{
    PEEK_OPTIONS_SCREEN(s);
    return &os->opt[PeekScreenOptionCurrentViewport];
}

void peekSetCurrentViewportNotify (CompScreen *s, peekScreenOptionChangeNotifyProc notify)
{
    PEEK_OPTIONS_SCREEN(s);
    os->notify[PeekScreenOptionCurrentViewport] = notify;
}

CompOption * peekGetDisplayOption (CompDisplay *d, PeekDisplayOptions num)
{
    PEEK_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

CompOption * peekGetScreenOption (CompScreen *s, PeekScreenOptions num)
{
    PEEK_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo peekOptionsDisplayOptionInfo[] = {
    { "timeout", "int", "<min>0</min><max>10000</max>", 0, 0 },
};

static Bool peekOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    PEEK_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, PeekDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case PeekDisplayOptionTimeout:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[PeekDisplayOptionTimeout])
                (*od->notify[PeekDisplayOptionTimeout]) (d, o, PeekDisplayOptionTimeout);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * peekOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    PEEK_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = PeekDisplayOptionNum;
    return od->opt;
}

static const CompMetadataOptionInfo peekOptionsScreenOptionInfo[] = {
    { "window_match", "match", 0, 0, 0 },
    { "active_opacity", "int", "<min>1</min><max>100</max>", 0, 0 },
    { "passive_opacity", "int", "<min>1</min><max>100</max>", 0, 0 },
    { "current_viewport", "bool", 0, 0, 0 },
};

static Bool peekOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    PEEK_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, PeekScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case PeekScreenOptionWindowMatch:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PeekScreenOptionWindowMatch])
                (*os->notify[PeekScreenOptionWindowMatch]) (s, o, PeekScreenOptionWindowMatch);
            return TRUE;
        }
        break;
     case PeekScreenOptionActiveOpacity:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PeekScreenOptionActiveOpacity])
                (*os->notify[PeekScreenOptionActiveOpacity]) (s, o, PeekScreenOptionActiveOpacity);
            return TRUE;
        }
        break;
     case PeekScreenOptionPassiveOpacity:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PeekScreenOptionPassiveOpacity])
                (*os->notify[PeekScreenOptionPassiveOpacity]) (s, o, PeekScreenOptionPassiveOpacity);
            return TRUE;
        }
        break;
     case PeekScreenOptionCurrentViewport:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PeekScreenOptionCurrentViewport])
                (*os->notify[PeekScreenOptionCurrentViewport]) (s, o, PeekScreenOptionCurrentViewport);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * peekOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    PEEK_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = PeekScreenOptionNum;
    return os->opt;
}

static Bool peekOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    PeekOptionsScreen *os;
    
    PEEK_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(PeekOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &peekOptionsMetadata, peekOptionsScreenOptionInfo, os->opt, PeekScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void peekOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    PEEK_OPTIONS_SCREEN (s);
    PEEK_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, PeekScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool peekOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    PeekOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(PeekOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[PeekOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &peekOptionsMetadata, peekOptionsDisplayOptionInfo, od->opt, PeekDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }

    return TRUE;
}

static void peekOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    PEEK_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, PeekDisplayOptionNum);

    free (od);
    d->base.privates[PeekOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool peekOptionsInit (CompPlugin *p)
{
    PeekOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (PeekOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&peekOptionsMetadata, "peek",peekOptionsDisplayOptionInfo, PeekDisplayOptionNum, peekOptionsScreenOptionInfo, PeekScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&peekOptionsMetadata, "peek");
    if (peekPluginVTable && peekPluginVTable->init)
        return peekPluginVTable->init (p);
    return TRUE;
}

static void peekOptionsFini (CompPlugin *p)
{
    if (peekPluginVTable && peekPluginVTable->fini)
        peekPluginVTable->fini (p);

    if (PeekOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (PeekOptionsDisplayPrivateIndex);

    compFiniMetadata (&peekOptionsMetadata);
}

static CompBool peekOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) peekOptionsInitDisplay,
        (InitPluginObjectProc) peekOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void peekOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) peekOptionsFiniDisplay,
        (FiniPluginObjectProc) peekOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool peekOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = peekOptionsInitObject (p, o);
    if (peekPluginVTable->initObject)
        rv &= peekPluginVTable->initObject (p, o);
    return rv;
}

static void peekOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (peekPluginVTable->finiObject)
        peekPluginVTable->finiObject (p, o);
    peekOptionsFiniObject (p, o);
}

static CompOption * peekOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) peekOptionsGetDisplayOptions,
        (GetPluginObjectOptionsProc) peekOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool peekOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) peekOptionsSetDisplayOption,
        (SetPluginObjectOptionProc) peekOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
peekOptionsGetMetadata (CompPlugin *plugin)
{
    return &peekOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!peekPluginVTable)
    {
        peekPluginVTable = getCompPluginInfo ();
        memcpy(&peekOptionsVTable, peekPluginVTable, sizeof(CompPluginVTable));
        peekOptionsVTable.getMetadata = peekOptionsGetMetadata;
        peekOptionsVTable.init = peekOptionsInit;
        peekOptionsVTable.fini = peekOptionsFini;
        peekOptionsVTable.initObject = peekOptionsInitObjectWrapper;
        peekOptionsVTable.finiObject = peekOptionsFiniObjectWrapper;
        peekOptionsVTable.getObjectOptions = peekOptionsGetObjectOptions;
	peekOptionsVTable.setObjectOption = peekOptionsSetObjectOption;
	
    }
    return &peekOptionsVTable;
}

