/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "prompt_options.h"

static int PromptOptionsDisplayPrivateIndex;

static CompMetadata promptOptionsMetadata;

static CompPluginVTable *promptPluginVTable = NULL;
CompPluginVTable promptOptionsVTable;

#define PROMPT_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, PromptOptions, o)
#define PROMPT_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, PromptOptions, o)

typedef struct _PromptOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[PromptDisplayOptionNum];
    promptDisplayOptionChangeNotifyProc notify[PromptDisplayOptionNum];
} PromptOptionsDisplay;

typedef struct _PromptOptionsScreen
{
    CompOption opt[PromptScreenOptionNum];
    promptScreenOptionChangeNotifyProc notify[PromptScreenOptionNum];
} PromptOptionsScreen;

CompAction * promptGetDisplayText (CompDisplay *d)
{
    PROMPT_OPTIONS_DISPLAY(d);
    return &od->opt[PromptDisplayOptionDisplayText].value.action;
}

void promptSetDisplayTextInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    PROMPT_OPTIONS_DISPLAY(d);
    od->opt[PromptDisplayOptionDisplayText].value.action.initiate = init;
}

void promptSetDisplayTextTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    PROMPT_OPTIONS_DISPLAY(d);
    od->opt[PromptDisplayOptionDisplayText].value.action.terminate = term;
}

CompOption * promptGetDisplayTextOption (CompDisplay *d)
{
    PROMPT_OPTIONS_DISPLAY(d);
    return &od->opt[PromptDisplayOptionDisplayText];
}

void promptSetDisplayTextNotify (CompDisplay *d, promptDisplayOptionChangeNotifyProc notify)
{
    PROMPT_OPTIONS_DISPLAY(d);
    od->notify[PromptDisplayOptionDisplayText] = notify;
}

unsigned short * promptGetTitleFontColor (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleFontColor].value.c;
}

unsigned short promptGetTitleFontColorRed (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleFontColor].value.c[0];
}

unsigned short promptGetTitleFontColorGreen (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleFontColor].value.c[1];
}

unsigned short promptGetTitleFontColorBlue (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleFontColor].value.c[2];
}

unsigned short promptGetTitleFontColorAlpha (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleFontColor].value.c[3];
}

CompOption * promptGetTitleFontColorOption (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return &os->opt[PromptScreenOptionTitleFontColor];
}

void promptSetTitleFontColorNotify (CompScreen *s, promptScreenOptionChangeNotifyProc notify)
{
    PROMPT_OPTIONS_SCREEN(s);
    os->notify[PromptScreenOptionTitleFontColor] = notify;
}

int promptGetTitleFontSize (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleFontSize].value.i;
}

CompOption * promptGetTitleFontSizeOption (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return &os->opt[PromptScreenOptionTitleFontSize];
}

void promptSetTitleFontSizeNotify (CompScreen *s, promptScreenOptionChangeNotifyProc notify)
{
    PROMPT_OPTIONS_SCREEN(s);
    os->notify[PromptScreenOptionTitleFontSize] = notify;
}

unsigned short * promptGetTitleBackColor (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleBackColor].value.c;
}

unsigned short promptGetTitleBackColorRed (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleBackColor].value.c[0];
}

unsigned short promptGetTitleBackColorGreen (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleBackColor].value.c[1];
}

unsigned short promptGetTitleBackColorBlue (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleBackColor].value.c[2];
}

unsigned short promptGetTitleBackColorAlpha (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return os->opt[PromptScreenOptionTitleBackColor].value.c[3];
}

CompOption * promptGetTitleBackColorOption (CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN(s);
    return &os->opt[PromptScreenOptionTitleBackColor];
}

void promptSetTitleBackColorNotify (CompScreen *s, promptScreenOptionChangeNotifyProc notify)
{
    PROMPT_OPTIONS_SCREEN(s);
    os->notify[PromptScreenOptionTitleBackColor] = notify;
}

CompOption * promptGetDisplayOption (CompDisplay *d, PromptDisplayOptions num)
{
    PROMPT_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

CompOption * promptGetScreenOption (CompScreen *s, PromptScreenOptions num)
{
    PROMPT_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo promptOptionsDisplayOptionInfo[] = {
    { "display_text", "action", 0, 0, 0 },
};

static Bool promptOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    PROMPT_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, PromptDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case PromptDisplayOptionDisplayText:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[PromptDisplayOptionDisplayText])
                (*od->notify[PromptDisplayOptionDisplayText]) (d, o, PromptDisplayOptionDisplayText);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * promptOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    PROMPT_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = PromptDisplayOptionNum;
    return od->opt;
}

static const CompMetadataOptionInfo promptOptionsScreenOptionInfo[] = {
    { "title_font_color", "color", 0, 0, 0 },
    { "title_font_size", "int", "<min>6</min><max>96</max>", 0, 0 },
    { "title_back_color", "color", 0, 0, 0 },
};

static Bool promptOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    PROMPT_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, PromptScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case PromptScreenOptionTitleFontColor:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PromptScreenOptionTitleFontColor])
                (*os->notify[PromptScreenOptionTitleFontColor]) (s, o, PromptScreenOptionTitleFontColor);
            return TRUE;
        }
        break;
     case PromptScreenOptionTitleFontSize:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PromptScreenOptionTitleFontSize])
                (*os->notify[PromptScreenOptionTitleFontSize]) (s, o, PromptScreenOptionTitleFontSize);
            return TRUE;
        }
        break;
     case PromptScreenOptionTitleBackColor:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[PromptScreenOptionTitleBackColor])
                (*os->notify[PromptScreenOptionTitleBackColor]) (s, o, PromptScreenOptionTitleBackColor);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * promptOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    PROMPT_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = PromptScreenOptionNum;
    return os->opt;
}

static Bool promptOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    PromptOptionsScreen *os;
    
    PROMPT_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(PromptOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &promptOptionsMetadata, promptOptionsScreenOptionInfo, os->opt, PromptScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void promptOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    PROMPT_OPTIONS_SCREEN (s);
    PROMPT_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, PromptScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool promptOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    PromptOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(PromptOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[PromptOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &promptOptionsMetadata, promptOptionsDisplayOptionInfo, od->opt, PromptDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }

    return TRUE;
}

static void promptOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    PROMPT_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, PromptDisplayOptionNum);

    free (od);
    d->base.privates[PromptOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool promptOptionsInit (CompPlugin *p)
{
    PromptOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (PromptOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&promptOptionsMetadata, "prompt",promptOptionsDisplayOptionInfo, PromptDisplayOptionNum, promptOptionsScreenOptionInfo, PromptScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&promptOptionsMetadata, "prompt");
    if (promptPluginVTable && promptPluginVTable->init)
        return promptPluginVTable->init (p);
    return TRUE;
}

static void promptOptionsFini (CompPlugin *p)
{
    if (promptPluginVTable && promptPluginVTable->fini)
        promptPluginVTable->fini (p);

    if (PromptOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (PromptOptionsDisplayPrivateIndex);

    compFiniMetadata (&promptOptionsMetadata);
}

static CompBool promptOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) promptOptionsInitDisplay,
        (InitPluginObjectProc) promptOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void promptOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) promptOptionsFiniDisplay,
        (FiniPluginObjectProc) promptOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool promptOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = promptOptionsInitObject (p, o);
    if (promptPluginVTable->initObject)
        rv &= promptPluginVTable->initObject (p, o);
    return rv;
}

static void promptOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (promptPluginVTable->finiObject)
        promptPluginVTable->finiObject (p, o);
    promptOptionsFiniObject (p, o);
}

static CompOption * promptOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) promptOptionsGetDisplayOptions,
        (GetPluginObjectOptionsProc) promptOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool promptOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) promptOptionsSetDisplayOption,
        (SetPluginObjectOptionProc) promptOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
promptOptionsGetMetadata (CompPlugin *plugin)
{
    return &promptOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!promptPluginVTable)
    {
        promptPluginVTable = getCompPluginInfo ();
        memcpy(&promptOptionsVTable, promptPluginVTable, sizeof(CompPluginVTable));
        promptOptionsVTable.getMetadata = promptOptionsGetMetadata;
        promptOptionsVTable.init = promptOptionsInit;
        promptOptionsVTable.fini = promptOptionsFini;
        promptOptionsVTable.initObject = promptOptionsInitObjectWrapper;
        promptOptionsVTable.finiObject = promptOptionsFiniObjectWrapper;
        promptOptionsVTable.getObjectOptions = promptOptionsGetObjectOptions;
	promptOptionsVTable.setObjectOption = promptOptionsSetObjectOption;
	
    }
    return &promptOptionsVTable;
}

