/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ROACH_OPTIONS_H
#define _ROACH_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    RoachDisplayOptionNumLeaves,
    RoachDisplayOptionLeafSize,
    RoachDisplayOptionAutumnUpdateDelay,
    RoachDisplayOptionScreenBoxing,
    RoachDisplayOptionScreenDepth,
    RoachDisplayOptionLeavesOverWindows,
    RoachDisplayOptionLeafRotation,
    RoachDisplayOptionWindDirection,
    RoachDisplayOptionLeafTextures,
    RoachDisplayOptionDefaultEnabled,
    RoachDisplayOptionUseBlending,
    RoachDisplayOptionUseTextures,
    RoachDisplayOptionToggleKey,
    RoachDisplayOptionNum
} RoachDisplayOptions;

typedef void (*roachDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, RoachDisplayOptions num);

CompOption *roachGetDisplayOption (CompDisplay *d, RoachDisplayOptions num);

typedef enum
{
    RoachScreenOptionNum
} RoachScreenOptions;

typedef void (*roachScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, RoachScreenOptions num);

CompOption *roachGetScreenOption (CompScreen *s, RoachScreenOptions num);

typedef enum
{
    WindDirectionNoWind = 0,
    WindDirectionUp = 1,
    WindDirectionLeft = 2,
    WindDirectionRight = 3,
} RoachWindDirectionEnum;

int              roachGetNumLeaves (CompDisplay *d);
CompOption *     roachGetNumLeavesOption (CompDisplay *d);
void             roachSetNumLeavesNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

float            roachGetLeafSize (CompDisplay *d);
CompOption *     roachGetLeafSizeOption (CompDisplay *d);
void             roachSetLeafSizeNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

int              roachGetAutumnUpdateDelay (CompDisplay *d);
CompOption *     roachGetAutumnUpdateDelayOption (CompDisplay *d);
void             roachSetAutumnUpdateDelayNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

int              roachGetScreenBoxing (CompDisplay *d);
CompOption *     roachGetScreenBoxingOption (CompDisplay *d);
void             roachSetScreenBoxingNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

int              roachGetScreenDepth (CompDisplay *d);
CompOption *     roachGetScreenDepthOption (CompDisplay *d);
void             roachSetScreenDepthNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

Bool             roachGetLeavesOverWindows (CompDisplay *d);
CompOption *     roachGetLeavesOverWindowsOption (CompDisplay *d);
void             roachSetLeavesOverWindowsNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

Bool             roachGetLeafRotation (CompDisplay *d);
CompOption *     roachGetLeafRotationOption (CompDisplay *d);
void             roachSetLeafRotationNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

int              roachGetWindDirection (CompDisplay *d);
CompOption *     roachGetWindDirectionOption (CompDisplay *d);
void             roachSetWindDirectionNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

CompListValue *  roachGetLeafTextures (CompDisplay *d);
CompOption *     roachGetLeafTexturesOption (CompDisplay *d);
void             roachSetLeafTexturesNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

Bool             roachGetDefaultEnabled (CompDisplay *d);
CompOption *     roachGetDefaultEnabledOption (CompDisplay *d);
void             roachSetDefaultEnabledNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

Bool             roachGetUseBlending (CompDisplay *d);
CompOption *     roachGetUseBlendingOption (CompDisplay *d);
void             roachSetUseBlendingNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

Bool             roachGetUseTextures (CompDisplay *d);
CompOption *     roachGetUseTexturesOption (CompDisplay *d);
void             roachSetUseTexturesNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

CompAction *     roachGetToggleKey (CompDisplay *d);
void             roachSetToggleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             roachSetToggleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     roachGetToggleKeyOption (CompDisplay *d);
void             roachSetToggleKeyNotify (CompDisplay *d, roachDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
