/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "showrepaint_options.h"

static int ShowrepaintOptionsDisplayPrivateIndex;

static CompMetadata showrepaintOptionsMetadata;

static CompPluginVTable *showrepaintPluginVTable = NULL;
CompPluginVTable showrepaintOptionsVTable;

#define SHOWREPAINT_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, ShowrepaintOptions, o)
#define SHOWREPAINT_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, ShowrepaintOptions, o)

typedef struct _ShowrepaintOptionsDisplay
{
    int screenPrivateIndex;

} ShowrepaintOptionsDisplay;

typedef struct _ShowrepaintOptionsScreen
{
} ShowrepaintOptionsScreen;

static Bool showrepaintOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    ShowrepaintOptionsScreen *os;
    
    SHOWREPAINT_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(ShowrepaintOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    
    return TRUE;
}

static void showrepaintOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    SHOWREPAINT_OPTIONS_SCREEN (s);
    SHOWREPAINT_OPTIONS_DISPLAY (s->display);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool showrepaintOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    ShowrepaintOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(ShowrepaintOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[ShowrepaintOptionsDisplayPrivateIndex].ptr = od;

    
    return TRUE;
}

static void showrepaintOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    SHOWREPAINT_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);
    free (od);
    d->base.privates[ShowrepaintOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool showrepaintOptionsInit (CompPlugin *p)
{
    ShowrepaintOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (ShowrepaintOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&showrepaintOptionsMetadata, "showrepaint",0, 0, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&showrepaintOptionsMetadata, "showrepaint");
    if (showrepaintPluginVTable && showrepaintPluginVTable->init)
        return showrepaintPluginVTable->init (p);
    return TRUE;
}

static void showrepaintOptionsFini (CompPlugin *p)
{
    if (showrepaintPluginVTable && showrepaintPluginVTable->fini)
        showrepaintPluginVTable->fini (p);

    if (ShowrepaintOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (ShowrepaintOptionsDisplayPrivateIndex);

    compFiniMetadata (&showrepaintOptionsMetadata);
}

static CompBool showrepaintOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) showrepaintOptionsInitDisplay,
        (InitPluginObjectProc) showrepaintOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void showrepaintOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) showrepaintOptionsFiniDisplay,
        (FiniPluginObjectProc) showrepaintOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool showrepaintOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = showrepaintOptionsInitObject (p, o);
    if (showrepaintPluginVTable->initObject)
        rv &= showrepaintPluginVTable->initObject (p, o);
    return rv;
}

static void showrepaintOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (showrepaintPluginVTable->finiObject)
        showrepaintPluginVTable->finiObject (p, o);
    showrepaintOptionsFiniObject (p, o);
}

static CompOption * showrepaintOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) 0,
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool showrepaintOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) 0,
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
showrepaintOptionsGetMetadata (CompPlugin *plugin)
{
    return &showrepaintOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!showrepaintPluginVTable)
    {
        showrepaintPluginVTable = getCompPluginInfo ();
        memcpy(&showrepaintOptionsVTable, showrepaintPluginVTable, sizeof(CompPluginVTable));
        showrepaintOptionsVTable.getMetadata = showrepaintOptionsGetMetadata;
        showrepaintOptionsVTable.init = showrepaintOptionsInit;
        showrepaintOptionsVTable.fini = showrepaintOptionsFini;
        showrepaintOptionsVTable.initObject = showrepaintOptionsInitObjectWrapper;
        showrepaintOptionsVTable.finiObject = showrepaintOptionsFiniObjectWrapper;
        showrepaintOptionsVTable.getObjectOptions = showrepaintOptionsGetObjectOptions;
	showrepaintOptionsVTable.setObjectOption = showrepaintOptionsSetObjectOption;
	
    }
    return &showrepaintOptionsVTable;
}

