/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "windowcapture_options.h"

static int WindowcaptureOptionsDisplayPrivateIndex;

static CompMetadata windowcaptureOptionsMetadata;

static CompPluginVTable *windowcapturePluginVTable = NULL;
CompPluginVTable windowcaptureOptionsVTable;

#define WINDOWCAPTURE_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, WindowcaptureOptions, o)
#define WINDOWCAPTURE_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, WindowcaptureOptions, o)

typedef struct _WindowcaptureOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[WindowcaptureDisplayOptionNum];
    windowcaptureDisplayOptionChangeNotifyProc notify[WindowcaptureDisplayOptionNum];
} WindowcaptureOptionsDisplay;

typedef struct _WindowcaptureOptionsScreen
{
} WindowcaptureOptionsScreen;

CompAction * windowcaptureGetWindowCaptureKey (CompDisplay *d)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    return &od->opt[WindowcaptureDisplayOptionWindowCaptureKey].value.action;
}

void windowcaptureSetWindowCaptureKeyInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    od->opt[WindowcaptureDisplayOptionWindowCaptureKey].value.action.initiate = init;
}

void windowcaptureSetWindowCaptureKeyTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    od->opt[WindowcaptureDisplayOptionWindowCaptureKey].value.action.terminate = term;
}

CompOption * windowcaptureGetWindowCaptureKeyOption (CompDisplay *d)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    return &od->opt[WindowcaptureDisplayOptionWindowCaptureKey];
}

void windowcaptureSetWindowCaptureKeyNotify (CompDisplay *d, windowcaptureDisplayOptionChangeNotifyProc notify)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    od->notify[WindowcaptureDisplayOptionWindowCaptureKey] = notify;
}

CompAction * windowcaptureGetWindowCaptureButton (CompDisplay *d)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    return &od->opt[WindowcaptureDisplayOptionWindowCaptureButton].value.action;
}

void windowcaptureSetWindowCaptureButtonInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    od->opt[WindowcaptureDisplayOptionWindowCaptureButton].value.action.initiate = init;
}

void windowcaptureSetWindowCaptureButtonTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    od->opt[WindowcaptureDisplayOptionWindowCaptureButton].value.action.terminate = term;
}

CompOption * windowcaptureGetWindowCaptureButtonOption (CompDisplay *d)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    return &od->opt[WindowcaptureDisplayOptionWindowCaptureButton];
}

void windowcaptureSetWindowCaptureButtonNotify (CompDisplay *d, windowcaptureDisplayOptionChangeNotifyProc notify)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    od->notify[WindowcaptureDisplayOptionWindowCaptureButton] = notify;
}

CompOption * windowcaptureGetDisplayOption (CompDisplay *d, WindowcaptureDisplayOptions num)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo windowcaptureOptionsDisplayOptionInfo[] = {
    { "window_capture_key", "key", 0, 0, 0 },
    { "window_capture_button", "button", 0, 0, 0 },
};

static Bool windowcaptureOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, WindowcaptureDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case WindowcaptureDisplayOptionWindowCaptureKey:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[WindowcaptureDisplayOptionWindowCaptureKey])
                (*od->notify[WindowcaptureDisplayOptionWindowCaptureKey]) (d, o, WindowcaptureDisplayOptionWindowCaptureKey);
            return TRUE;
        }
        break;
     case WindowcaptureDisplayOptionWindowCaptureButton:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[WindowcaptureDisplayOptionWindowCaptureButton])
                (*od->notify[WindowcaptureDisplayOptionWindowCaptureButton]) (d, o, WindowcaptureDisplayOptionWindowCaptureButton);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * windowcaptureOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = WindowcaptureDisplayOptionNum;
    return od->opt;
}

static Bool windowcaptureOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    WindowcaptureOptionsScreen *os;
    
    WINDOWCAPTURE_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(WindowcaptureOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    
    return TRUE;
}

static void windowcaptureOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    WINDOWCAPTURE_OPTIONS_SCREEN (s);
    WINDOWCAPTURE_OPTIONS_DISPLAY (s->display);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool windowcaptureOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    WindowcaptureOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(WindowcaptureOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[WindowcaptureOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &windowcaptureOptionsMetadata, windowcaptureOptionsDisplayOptionInfo, od->opt, WindowcaptureDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }

    return TRUE;
}

static void windowcaptureOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    WINDOWCAPTURE_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, WindowcaptureDisplayOptionNum);

    free (od);
    d->base.privates[WindowcaptureOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool windowcaptureOptionsInit (CompPlugin *p)
{
    WindowcaptureOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (WindowcaptureOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&windowcaptureOptionsMetadata, "windowcapture",windowcaptureOptionsDisplayOptionInfo, WindowcaptureDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&windowcaptureOptionsMetadata, "windowcapture");
    if (windowcapturePluginVTable && windowcapturePluginVTable->init)
        return windowcapturePluginVTable->init (p);
    return TRUE;
}

static void windowcaptureOptionsFini (CompPlugin *p)
{
    if (windowcapturePluginVTable && windowcapturePluginVTable->fini)
        windowcapturePluginVTable->fini (p);

    if (WindowcaptureOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (WindowcaptureOptionsDisplayPrivateIndex);

    compFiniMetadata (&windowcaptureOptionsMetadata);
}

static CompBool windowcaptureOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) windowcaptureOptionsInitDisplay,
        (InitPluginObjectProc) windowcaptureOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void windowcaptureOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) windowcaptureOptionsFiniDisplay,
        (FiniPluginObjectProc) windowcaptureOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool windowcaptureOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = windowcaptureOptionsInitObject (p, o);
    if (windowcapturePluginVTable->initObject)
        rv &= windowcapturePluginVTable->initObject (p, o);
    return rv;
}

static void windowcaptureOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (windowcapturePluginVTable->finiObject)
        windowcapturePluginVTable->finiObject (p, o);
    windowcaptureOptionsFiniObject (p, o);
}

static CompOption * windowcaptureOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) windowcaptureOptionsGetDisplayOptions,
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool windowcaptureOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) windowcaptureOptionsSetDisplayOption,
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
windowcaptureOptionsGetMetadata (CompPlugin *plugin)
{
    return &windowcaptureOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!windowcapturePluginVTable)
    {
        windowcapturePluginVTable = getCompPluginInfo ();
        memcpy(&windowcaptureOptionsVTable, windowcapturePluginVTable, sizeof(CompPluginVTable));
        windowcaptureOptionsVTable.getMetadata = windowcaptureOptionsGetMetadata;
        windowcaptureOptionsVTable.init = windowcaptureOptionsInit;
        windowcaptureOptionsVTable.fini = windowcaptureOptionsFini;
        windowcaptureOptionsVTable.initObject = windowcaptureOptionsInitObjectWrapper;
        windowcaptureOptionsVTable.finiObject = windowcaptureOptionsFiniObjectWrapper;
        windowcaptureOptionsVTable.getObjectOptions = windowcaptureOptionsGetObjectOptions;
	windowcaptureOptionsVTable.setObjectOption = windowcaptureOptionsSetObjectOption;
	
    }
    return &windowcaptureOptionsVTable;
}

